package de.accso.flexinale.backoffice.application.services;

import de.accso.flexinale.backoffice.domain.dao.KinoSaalDao;
import de.accso.flexinale.backoffice.domain.model.Kino;
import de.accso.flexinale.backoffice.domain.model.KinoSaal;
import de.accso.flexinale.common.domain.dao.AbstractDao;
import de.accso.flexinale.common.application.services.AbstractExcelDataUploadService;
import de.accso.flexinale.common.shared_kernel.FlexinaleIllegalArgumentException;
import de.accso.flexinale.common.shared_kernel.Identifiable;
import jakarta.transaction.Transactional;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

@Transactional
public class KinoSaalUploadService extends AbstractExcelDataUploadService<KinoSaal> {
    private static final Logger LOGGER = LoggerFactory.getLogger(KinoSaalUploadService.class);

    private final KinoSaalDao kinoSaalDao;

    public KinoSaalUploadService(final KinoSaalDao kinoSaalDao) {
        this.kinoSaalDao = kinoSaalDao;
    }

    @Override
    public AbstractDao<KinoSaal> getDao() {
        return kinoSaalDao;
    }

    @Override
    public String getNameOfExcelDataType() {
        return KinoSaal.class.getSimpleName();
    }

    @Override
    public KinoSaal createDataFromExcelRow(final Row excelRow) {
        String kinoSaalId = excelRow.getCell(0).getStringCellValue();

        String kinoId = excelRow.getCell(3).getStringCellValue();

        Cell cellAnzahlPlaetze = excelRow.getCell(2);
        int anzahlPlaetze =
                switch(cellAnzahlPlaetze.getCellType()) {
                    case NUMERIC -> (int) cellAnzahlPlaetze.getNumericCellValue();
                    case STRING  -> Integer.parseInt(cellAnzahlPlaetze.getStringCellValue());
                    default -> throw new FlexinaleIllegalArgumentException("Anzahl Plaetze is not a number");
                };

        KinoSaal kinoSaal = new KinoSaal(
                Identifiable.Id.of(kinoSaalId),
                new KinoSaal.Name(excelRow.getCell(1).getStringCellValue()),
                new KinoSaal.AnzahlPlaetze(anzahlPlaetze),
                new Kino(Identifiable.Id.of(kinoId))
        );

        LOGGER.debug("New KinoSaal created: " + kinoSaal);

        return kinoSaal;
    }

    public Map<Identifiable.Id, Collection<KinoSaal>> mapKinoSaeleToKino(final Collection<KinoSaal> kinoSaele) {
        Map<Identifiable.Id, Collection<KinoSaal>> saeleUndKinos = new HashMap<>();
        for (KinoSaal saal : kinoSaele) {
            Identifiable.Id key = saal.kino.id();

            Collection<KinoSaal> kinoSaeleAlreadyMapped = saeleUndKinos.get(key);
            if (kinoSaeleAlreadyMapped == null) {
                HashSet<KinoSaal> saele = new HashSet<>();
                saele.add(saal);
                saeleUndKinos.put(key, saele);
            }
            else {
                kinoSaeleAlreadyMapped.add(saal);
                saeleUndKinos.put(key, kinoSaeleAlreadyMapped);
            }
        }
        return saeleUndKinos;
    }
}
